#import <Foundation/Foundation.h>


/*
 
 Written by Sven-S. Porst (ssp-web@earthlingsoft.net)
 http://earthlingsoft.net/ssp/blog/2008/07/ssp_vs_mysql

 You have to edit the first line in the function to set the path to the database file.
 The database should be readable as UTF-8.
 
 The output will be written to /tmp/fixeddatabase.sql and overwrite stuff there.
 
 Be warned, use at your own risk, adjust to your needs.

*/




int main (int argc, const char * argv[]) {
	NSData * d = [NSData dataWithContentsOfFile:@"/Users/ssp/Desktop/web28db1.sql"];	

	NSString * s = [[NSString alloc] initWithData:d encoding:NSUTF8StringEncoding];
	
	NSArray * a = [s componentsSeparatedByString:@"\n"];
	NSMutableArray * b = [a mutableCopy];
	a = nil;
	
	NSMutableArray * b2 = [NSMutableArray arrayWithCapacity:b.count];

	int i = 0;
	for (NSString * kl in b) 
	{
		NSMutableString * goodString = [NSMutableString stringWithCapacity:kl.length];
		BOOL chars = YES;
		if (chars) {
			NSString * utf8string = kl;
			
			for (int j = 0; j < utf8string.length; j++) {
				if ([utf8string characterAtIndex:j] > 127) {
					NSString * precontext = [utf8string substringWithRange:NSMakeRange(MAX(0,j-15), 15)];
					
					NSString * wrongstring = @"";
					while ([utf8string characterAtIndex:j] > 127) {
						wrongstring =  [wrongstring stringByAppendingString:[utf8string substringWithRange:NSMakeRange(j, 1)]];
						j++;
					}
					j--;
					
					NSString * postcontext = [utf8string substringWithRange:NSMakeRange(j+1, MIN(15, utf8string.length - j - 1))];
					
					const char * tempISOstring = [wrongstring cStringUsingEncoding:NSISOLatin1StringEncoding];
					NSString * correctedISOstring = nil;
					if (tempISOstring) {
						correctedISOstring = [[NSString alloc] initWithBytes:tempISOstring length:strlen(tempISOstring) encoding:NSUTF8StringEncoding];
					}
					
					const char * tempCPstring = [wrongstring cStringUsingEncoding:NSWindowsCP1252StringEncoding];
					NSString * correctedCPstring = nil;
					if (tempCPstring) {
						correctedCPstring = [[NSString alloc] initWithBytes:tempCPstring length:strlen(tempCPstring) encoding:NSUTF8StringEncoding];
					}
					
										
					if ([correctedCPstring isEqualToString: correctedISOstring]) {
						NSLog(@"Line %i, char %i OK  → %@%@%@", [b indexOfObject:kl], j, precontext, correctedISOstring, postcontext);
							[goodString appendString:correctedISOstring];
					}
					else {
						if (!(correctedCPstring || correctedISOstring)) {
							NSLog(@"*** Line %i, char %i ***FAIL*** %@__%@__%@", [b indexOfObject:kl], j, precontext, wrongstring, postcontext);
							[goodString appendString:wrongstring];
						}
						else if (!correctedISOstring) {
							NSLog(@"Line %i, char %i CP1252 → %@__%@__%@ (Latin1 is nil)", [b indexOfObject:kl], j, precontext, correctedCPstring, postcontext);	
							[goodString appendString:correctedCPstring];
						}
						else if (!correctedCPstring) {
							NSLog(@"Line %i, char %i LATIN1 → %@__%@__%@ (CP1252 is nil)", [b indexOfObject:kl], j, precontext, correctedISOstring, postcontext);	
							[goodString appendString:correctedISOstring];
						}
						else {
							NSLog(@"*** Line %i, char %i ***DIFFER*** %@__%@__%@ (Latin1) vs %@__%@__%@ (CP1252)", [b indexOfObject:kl], j, precontext, correctedISOstring, postcontext, precontext, correctedCPstring, postcontext);
								[goodString appendString:correctedCPstring];
							}
						}					
					
				}
				else {
					// no correction necessary, just add the string
					[goodString appendString:[utf8string substringWithRange:NSMakeRange(j, 1)]];
				}
			}				
			
		}	else {
			NSLog(@"Problem with line %i --- DUMPED", [b indexOfObject:kl]);
			}
		i++;
		[b2 addObject:goodString];
	}
	
	NSString * s3 = [b2 componentsJoinedByString:@"\n"];
	[s3 writeToFile:@"/tmp/fixeddatabase.sql" atomically:NO encoding:NSUTF8StringEncoding error:NULL];
	
	return 0;
}